﻿using System;
using SmartVault.Core;
using SmartVault.Proto;
using SmartVault.Rest;
using System.IO;

namespace HelloWorldSVRest
{
    class SmartVault
    {
        private ClientProtocol _protocol;

        public SmartVault()
        {
            string clientId = "CSharpTutorial"; // Change this to your client ID
            string privateKey = "-----BEGIN RSA PRIVATE KEY-----\r\n" +
            "MIIEogIBAAKCAQEA0+UlqixNqRoNrZhRj90MP14SavZkMPxFhJEN0p23fxIlOIY0\r\n" +
            "4SW3IO5iyT5PUsOtK6Gigp2zn3uEMqAVI2MwR9fXBI7iVuOThIDTt+DygBHHWc52\r\n" +
            "6Fcd5aU8lxtg02SGJ5HZgKWI/8pHfQbd+pFPrEF50saVb/XPfN74OWx5pWsJbQz9\r\n" +
            "B8XodDswGzKmyqVeicPefSIn9qa2AkbLNhANbEgx+VE1p+L1X3r3z4sZ/Cks/5nr\r\n" +
            "2fO5AayhNzwTbN71s82M2Q5WgvxbM+ahSPHvtkgwzi9+XiEyOkUnkoftBSoxPZB1\r\n" +
            "GWYriEwCsp+iQljehKl/ugYbqBMn1kaqOP8xJQIDAQABAoIBAF4gFDMbqwPLBvhu\r\n" +
            "CQ0W7DHZ3+STvr3j0h2pMbK1TKWtscsCEstQraB7RHaQrzvcoDgZfM74rqnRfE/g\r\n" +
            "vIMTtIa1YlYsAm8GeKkLcQDlc9NgEmXaSQe8axNv6xJUnxZIOS+qoit7XPgDKu5m\r\n" +
            "9oQvuGyUSUFP5WHul1So1yrq/L51lp9rhRJLnKPjTlFsTLXjoh2StrmS3LHfvn3Y\r\n" +
            "3l/Ftk6mv+0Z0KXXIxCQR+Hn9193rwrOJ4NlgOPeeNjadhSRrZNdwoXw9Y55R9hw\r\n" +
            "3WxHHZPHeQi6K1kDm2UT8qG078p9d11QrzE6xBPMVP5s8GxJ5H+QfT7jLBJJ8w2F\r\n" +
            "w3NmyQECgYEA7+2V5OmJ2RBal8o/VIq/wwMn1YMqR4Tz5V2bFlV+HHVqF/SVDf8Q\r\n" +
            "nIs7/hsVeWGu2XWgLbL7TWngjkSjEx3prhbeuMLrOjpPlE8zTopUP8qkzHSAFYgw\r\n" +
            "NA5XaRxc55Guo9gRQQKj9/o9iTRoZZEuwA7oIguOVvEcGH9axJNFs4kCgYEA4hbW\r\n" +
            "YKrJMIdnb0Lbj0sUUbgXvbxUHpdL0iRKGGpZC7qauEUWyML+TqGQt47A9bsOxpuo\r\n" +
            "ZiHKcdeJ+Y6+S6klzTtUXFHnNnVtVj/d1TJe2WaiXWJPWOip1MzkmeaW7GlyZAG9\r\n" +
            "2ERB1pDv76e0ZefgLN5kCnbRb/dsEtyTz8IyPb0CgYA6ULvjFKRNnvz18dFswgCT\r\n" +
            "7Jts+OF42qbRM+wzBHqPfjZYNjlYWot2ER12yKxygTyXXFCfauZLzZUn3yTny5h1\r\n" +
            "mNdvfujfkTawbIOi7lpF2wItM4/CLATTUj0KrjsiibUx251t+K9T4X29cICDV0NO\r\n" +
            "qRDg3YAuP5I9ng64wrbpSQKBgEb9aL7doWKNgZrb4Vjy+CRYq4u18KvSUcpf/qv/\r\n" +
            "6InYQ/CMMQVExNknvesE9e2ymIcgJRY8kfaA+R/VBEd5ixcQBAMg7HqbEIO+dgcV\r\n" +
            "U9brdRvhXIzMMVdSJo10a/s7eOGR8mxPsmSPCee0Pt6omik8gykN+eEwTUz22aqo\r\n" +
            "jWH5AoGAYWd+y1wcI4ZkqdnoGbFapo2BjeZmFEV5KUhXWW7eJCmh6iD6hWr5b1ZR\r\n" +
            "6aQQyUNITq40JvIkTpgNO7bJ49+yL0SbCQXiJLoH2nvLK7sGLYOq0GQxD2sn3eLW\r\n" +
            "/qKTFd4LAK6dCMklQzr1Ev9cWMFm0DLUdOnKNv6zvme67Gs9xPE=\r\n" +
            "-----END RSA PRIVATE KEY-----\r\n";

            StringReader reader = new StringReader(privateKey);
            RSAKeyPair keyPair = RSAPrivateKey2.KeyPairFromPem(privateKey);
            ServerCfg cfg = new ServerCfg(clientId, keyPair.Private);

            Authentication auth = new Authentication(cfg);
            _protocol = auth.CreateClientProtocol();
        }

        public void SignUpUser(string firstName, string lastName, string phoneNumber, string accountName, string vaultName, string userEmail)
        {
            Console.WriteLine("Creating user...");
            SignUpNewUserRequest.Builder builder = SignUpNewUserRequest.CreateBuilder();
            builder.FirstName = firstName;
            builder.LastName = lastName;
            builder.PhoneNumber = phoneNumber;
            builder.AccountName = accountName;
            builder.VaultName = vaultName;
            builder.CreateVault = true;
            builder.Email = userEmail;
            builder.EmailValidated = true;  // only set this to true if your client program has the ability to validate the user has posession of this email account
            
            _protocol.SignUpNewUser(builder.Build());
        }
    }
}